#!/usr/bin/env node
import { inc as A, prerelease as y } from "semver";
import { join as v } from "node:path";
import { execSync as n } from "node:child_process";
import P from "pinyin";
import { readFileSync as O, existsSync as I } from "node:fs";
import p from "chalk";
import H from "prompts";
import w from "yargs";
import { hideBin as J } from "yargs/helpers";
var E = /* @__PURE__ */ ((t) => (t.NPM = "npm", t.WEB = "web", t))(E || {}), e = /* @__PURE__ */ ((t) => (t.MAJOR = "major", t.MINOR = "minor", t.PATCH = "patch", t.PREMAJOR = "premajor", t.PREMINOR = "preminor", t.PREPATCH = "prepatch", t.PRERELEASE = "prerelease", t))(e || {}), d = /* @__PURE__ */ ((t) => (t.LATEST = "latest", t.NEXT = "next", t.ALPHA = "alpha", t))(d || {});
const L = "/.dc/publish.json", u = "/package.json", T = ({ gitOriginName: t = "origin" }) => {
  try {
    const o = n("git rev-parse HEAD").toString().trim(), g = n('git log -1 --pretty=format:"%an"').toString().trim(), c = n('git log -1 --pretty=format:"%ae"').toString().trim(), i = n('git log -1 --pretty=format:"%s"').toString().trim(), s = n("git config user.name").toString().trim(), l = n("git config user.email").toString().trim(), m = n("git rev-parse --abbrev-ref HEAD").toString().trim();
    let f = "";
    try {
      f = n(`git config --get remote.${t}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${t} 不存在`);
    }
    return {
      lastHash: o,
      lastCommitter: g,
      lastCommitterPinYin: P(g, {
        style: P.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: c,
      lastCommitMsg: i,
      userName: s,
      userNamePinYin: P(s, {
        style: P.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: l,
      branchName: m,
      remoteUrl: f
    };
  } catch (o) {
    throw console.error("Error fetching git information:", o), o;
  }
}, R = (t, o = JSON.parse(O(v(process.cwd(), u), "utf-8"))) => {
  let g = o.name, c = "", i;
  const { version: s } = o;
  if ([
    e.MAJOR,
    e.MINOR,
    e.PATCH
  ].includes(t))
    c = A(s, t), i = d.LATEST;
  else if ([
    e.PREMAJOR,
    e.PREMINOR,
    e.PREPATCH
  ].includes(t)) {
    const l = y(s);
    l ? (console.log(
      p.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), l.length === 1 && typeof l[0] == "number" ? c = A(
      s,
      e.PRERELEASE
    ) : c = s.split("-")[0] + "-0") : c = A(s, t), i = d.NEXT;
  } else
    i = d.ALPHA, c = A(
      s,
      e.PRERELEASE,
      i
    );
  if (!c)
    throw new Error("version is empty");
  return {
    name: g,
    version: c,
    tag: i
  };
}, b = () => {
  let t;
  const o = v(process.cwd(), L);
  if (I(o)) {
    const g = O(o, "utf-8");
    t = JSON.parse(g);
  } else
    console.log(
      p.yellow(`未找到配置文件，将使用默认配置
      { gitOriginName: "origin" }
    `)
    );
  return {
    gitOriginName: "origin",
    ...t || {}
  };
}, N = async (t) => {
  console.log(t);
  const { mode: o, type: g, push: c } = t, i = b(), s = T(i);
  console.log("gitInfo:", s);
  let l = g, m;
  if (l)
    console.log("type:", l), m = await R(l);
  else {
    const r = JSON.parse(O(v(process.cwd(), u), "utf-8")), a = {
      [e.MAJOR]: R(
        e.MAJOR,
        r
      ),
      [e.MINOR]: R(
        e.MINOR,
        r
      ),
      [e.PATCH]: R(
        e.PATCH,
        r
      ),
      [e.PREMAJOR]: R(
        e.PREMAJOR,
        r
      ),
      [e.PREMINOR]: R(
        e.PREMINOR,
        r
      ),
      [e.PREPATCH]: R(
        e.PREPATCH,
        r
      ),
      [e.PRERELEASE]: R(
        e.PRERELEASE,
        r
      )
    }, $ = [
      {
        title: `主版本(${a[e.MAJOR].version})`,
        value: e.MAJOR
      },
      {
        title: `次版本(${a[e.MINOR].version})`,
        value: e.MINOR
      },
      {
        title: `修订版本(${a[e.PATCH].version})`,
        value: e.PATCH
      },
      {
        title: `预发布主版本(${a[e.PREMAJOR].version})`,
        value: e.PREMAJOR
      },
      {
        title: `预发布次版本(${a[e.PREMINOR].version})`,
        value: e.PREMINOR
      },
      {
        title: `预发布修订版本(${a[e.PREPATCH].version})`,
        value: e.PREPATCH
      },
      {
        title: `alpha版本(${a[e.PRERELEASE].version})`,
        value: e.PRERELEASE
      }
    ];
    l = (await H({
      type: "select",
      name: "type",
      message: `请选择发布类型，当前版本：${r.version}`,
      choices: $,
      validate: (C) => C ? !0 : "请选择发布类型"
    })).type, m = a[l];
  }
  const { version: f } = m;
  console.log("npmInfo:", m), n(`npm version ${f} 1>&2`);
  try {
    if (o === E.NPM) {
      const { tag: r } = m;
      n(`npm publish --tag ${r} 1>&2`);
    } else if (o === E.WEB) {
      const { webBuild: r } = i;
      r ? n(`${r} 1>&2`) : console.log(p.yellow("webBuild为空，不执行web构建"));
    } else
      throw new Error("未知命令");
  } catch (r) {
    console.log(p.red(`发布失败, error: ${r.message}`));
    try {
      console.log(
        p.blue(`回滚本地版本到发布前的版本：${s.lastHash}`)
      );
      const { lastHash: a } = s;
      n(`git reset --hard ${a} 1>&2`), console.log(p.blue(`删除本次发布时生成的tag：v${m.version}`)), n(`git tag -d v${m.version} 1>&2`);
    } catch (a) {
      console.log(p.red(`回滚失败, error: ${a.message}`));
    }
    return process.exit(1);
  }
  c && (n(`git push ${i.gitOriginName} v${m.version} 1>&2`), n(`git push ${i.gitOriginName} ${s.branchName} 1>&2`)), console.log(p.green("发布成功"));
}, h = {
  version: "0.4.2",
  name: "@done-coding/cli-publish",
  description: "项目发布命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "publish"
  }
}, j = () => ({
  mode: {
    alias: "m",
    describe: "发布模式",
    choices: [E.NPM, E.WEB],
    default: E.NPM
  },
  type: {
    alias: "t",
    describe: "发布类型",
    choices: [
      e.MAJOR,
      e.MINOR,
      e.PATCH,
      e.PREMAJOR,
      e.PREMINOR,
      e.PREPATCH,
      e.PRERELEASE
    ]
  },
  push: {
    alias: "p",
    describe: "是否推送至远程仓库",
    type: "boolean",
    default: !0
  }
}), M = h.cliConfig.moduleName, x = (t, o) => {
  console.log(t ? p.red(t) : p.red(o.message)), process.exit(1);
}, B = h.description, U = `Usage: $0 ${M} [options]`, D = "Usage: $0 [options]", S = (t, o) => {
  const g = j();
  return t.strict().usage(o).help("help").version(h.version).alias("v", "version").alias("h", "help").options(g).fail(x).argv;
}, Y = (t) => S(t, U), Q = {
  command: M,
  describe: B,
  builder: Y,
  handler: N
}, Z = async () => {
  const t = w(J(process.argv)), o = await S(t, D);
  return N(o);
};
export {
  E as P,
  Q as a,
  Z as c,
  N as h
};
